#include <iostream>
#include <mpi.h>

using namespace std;

void master(int brojProcesa) {
  double poruka;
  poruka=3.14159;
  MPI::COMM_WORLD.Bcast(&poruka,1,MPI::DOUBLE,0);
}

void slave(int procesID) {
  double poruka;
  MPI::COMM_WORLD.Bcast(&poruka,1,MPI::DOUBLE,0);
  cout << "Process " << procesID << " je primio " << poruka << " od master procesa " << endl;
}

int main(int argc, char **argv) {

  MPI::Init(argc, argv);
  int mojID       = MPI::COMM_WORLD.Get_rank();
  int brojProcesa = MPI::COMM_WORLD.Get_size();
  
  if (mojID==0)
    master(brojProcesa);
  else
    slave(mojID);
  
  MPI::Finalize();
}
